#define TRUE 1
#define FALSE 0

#define TILE_WIDTH 128
#define TILE_HEIGHT 128

#define MOUSE_LEFT 1
#define MOUSE_MIDDLE 4
#define MOUSE_RIGHT 2

#define isodd(n) ((n)%2)
#define iseven(n) !isodd(n)

#define PI 3.14159265359

proc
	sign(n) . = n && n / abs(n)

	lerp(a, b, c) . = a*(1-c) + b*c

	atan2(x, y) . = (x||y) && (x>=0?arccos(y/sqrt(x*x+y*y)):360-arccos(y/sqrt(x*x+y*y)))

	dir2dx(dir)
		var global/dir2dx[] = list(0, 0, 0, 1, 1, 1, 0, -1, -1, -1, -1, 0, 0, 0, 0)
		. = (dir in 1 to 15) && dir2dx[dir]

	dir2dy(dir)
		var global/dir2dy[] = list(1, -1, 0, 0, 1, -1, 0, 0, 1, -1, 0, 0, 1, -1, 0)
		. = (dir in 1 to 15) && dir2dy[dir]

	// [center]: fallback angle, when dir is conflicted (e.g. NORTH|SOUTH)
	dir2angle(dir, center = 0)
		var global/dir2angle[] = list(0, 180, 1.#IND, 90, 45, 135, 90, 270, 315, 225, 270, 1.#IND, 0, 180, 1.#IND)
		if(dir in 1 to 15)
			. = dir2angle[dir]
			if(. == 1.#IND)
				. = center

#define randn(a, b) lerp(a, b, rand())
#define clamp(n, a, b) min(max(n, a), b)
#define hypot(x, y) sqrt(x*x+y*y)