#define vec2(x, y) list(x, y)
#define vec2p(r, t) vec2(r*sin(t), r*cos(t))
#define vec2_zero vec2(0, 0)
proc
	isvec2(a) . = istype(a, /list) && a:len == 2
	vec2_add(a, b) . = vec2(a[1]+b[1], a[2]+b[2])
	vec2_subtract(a, b) . = vec2(a[1]-b[1], a[2]-b[2])
	vec2_scale(a, s) . = vec2(a[1]*s, a[2]*s)
	vec2_dot(a, b) . = a[1]*b[1] + a[2]*b[2]
	vec2_cross(a, b) . = a[1]*b[2] - a[2]*b[1] // z when a.z && b.z == 0
	vec2_magnitude(a) . = sqrt(vec2_dot(a, a))
	vec2_unit(a) . = vec2_scale(a, 1/vec2_magnitude(a))
	vec2_scale_to(a, mag) . = vec2_scale(a, mag/vec2_magnitude(a))
	vec2_angle(a) . = atan2(a[1], a[2])
	vec2_to(a, b) . = vec2_subtract(b, a)
	vec2_angle_to(a, b) . = vec2_angle(vec2_to(a, b))
	vec2_iszero(a) . = isvec2(a) && !(a[1] || a[2])
	vec2_text(a) . = "([a[1]], [a[2]])"
	vec2_lerp(a, b, t) . = vec2(lerp(a[1], b[1], t), lerp(a[2], b[2], t))
	clamp_angle(a) . = a - round(a / 360, 1) * 360

	angle_difference(a, b) . = clamp_angle(clamp_angle(a) - clamp_angle(b))
	/*
		var forward[] = vec2p(1, a)
		var toward[] = vec2p(1, b)
		var cross = vec2_cross(forward, toward)
		var angle_diff = -arcsin(cross)
		if(vec2_dot(forward, toward) < 0) angle_diff = 180 - angle_diff
		if(angle_diff < 0) angle_diff += 360
		if(angle_diff > 180) angle_diff -= 360
		return angle_diff
	*/